/*  GNU Ocrad - Optical Character Recognition program
    Copyright (C) 2003, 2004, 2005 Antonio Diaz Diaz.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

class Blockmap;
class Textblock;

class Textpage : public Rectangle
  {
  const std::string name;
  const Blockmap * bmp;
  std::vector< Textblock * > tbpv;

public:
  Textpage( const Bitmap & page_image, const char * filename,
            const Control & control ) throw();
  ~Textpage() throw();

//  const Blockmap & blockmap() const throw() { return *bmp; }
//  const Textblock & textblock( int i ) const throw();
  int textblocks() const throw() { return tbpv.size(); }

  void print( const Control & control ) const throw();
  void xprint( const Control & control ) const throw();
  };
